;ͻ
;   IRot.Lsp                                           Jan 06, 1996   
;   Rotate Insert Using Insert Point As Base In Current UCS           
;ͼ
;================== Start Program ======================================
(princ "\nLoading IRot v1.3   ")                ;Program Loader
(setq IRot nil)                                 ;Reset Program Name
;%%%%%%%%%%%%%%%%%% Macros %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
(defun PDot ()(princ "."))                     ;Print Dots
(defun BkSp () (write-char '8))                ;Define Back Space
(defun AtoR (a) (* pi (/ a 180.0)))            ;Angle To Radian
(defun RtoA (r) (/ (* r 180.0) pi))            ;Radian To Angle
(defun GetVal (n e) (cdr (assoc n e)))         ;Get Association Value
(defun Beep (/ f) (setq f (open "con" "w"))    ;Define Beep
      (write-char '7 f) (close f))             ;Print Hex 7 To CON
(defun Err (e) (beep)                          ;An Augmented
               (princ (strcat "\nError: " e))  ;User Error
               (quit))                         ;Routine
(defun Warn (w) (beep)                         ;An Augmented Warning
                (princ (strcat "\nWarning !: " w "\n"))
                (prin1))                       ;Routine

;%%%%%%%%%%%%%%%%%% Sub Routines %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
(PDot);++++++++++++ Set Modes & Error ++++++++++++++++++++++++++++++++++
;Variables  m_l ModeList  m_s ModeSetting  m_n OldName  m_v OldValue
 (defun ir_smd ()                              ;Define ir_smd
  (command "UNDO" "MARK")                      ;Set An Undo Mark
  (setq m_v nil m_n nil                        ;Reset Mode Name & Value
        m_l (list "CMDECHO" "BLIPMODE" "HIGHLIGHT")
        m_s (list 0 0 1)                       ;Setup New Modes
     olderr *error*                            ;Get Old Error
    *error* (lambda (s)                        ;Set User Error So That
     (cond ((= s "Function cancelled"))        ;If Cancel Or
           ((= s "quit / exit abort"))         ;Abort Exit Clean
           ((princ (strcat "\nError: " s))))   ;Else Print Error
     (ir_rmd)))                                ;Then Return Old Modes
  (foreach x m_l (setq m_v (cons (getvar x) m_v);Get Old Mode Values
                       m_n (cons x m_n)))      ;And Variables
  (mapcar 'setvar m_l m_s)                     ;Set New Modes
  (princ "\nInsert Rotation Routine ...."))    ;Display Program
(PDot);++++++++++++ Return Modes & Error +++++++++++++++++++++++++++++++
 (defun ir_rmd ()                              ;Define ir_rmd
  (setq *error* olderr)                        ;Reset Error
  (mapcar 'setvar m_n m_v)                     ;Reset Modes
  (prin1))                                     ;Exit Clean

(PDot);++++++++++++ Point To String ++++++++++++++++++++++++++++++++++++
;Caller To Supply Point  ie. (ir_p2s '0 0 6)    ;Define ir_p2s
(defun ir_p2s (ppt)                             ;List Augment
 (setq spt "")                                  ;Reset String
  (foreach x ppt (setq spt (strcat spt (rtos x) "," )))
   (setq spt (substr spt  1 (1- (strlen spt)))));Compile New String

(PDot);++++++++++++ Get Entity Name ++++++++++++++++++++++++++++++++++++
(defun GetOne (/ st os)                        ;Define GetOne
 (setq os (getvar "SNAPMODE") s nil)           ;Set Old Snap & EName
 (setvar "SNAPMODE" 0)                         ;Turn Snaps Off
 (while (not st)                               ;Force Choice
        (setq st (ssget)))                     ;Allows L P C W
 (while (> (sslength st) 1)                    ;If More Than 1
        (setq st nil)                          ;Selected
        (princ "\nOnly 1 At A Time Please\n")  ;Inform User
        (while (not st)                        ;And Try Again
               (setq st (ssget))))             ;Allows L P C W
 (setvar "SNAPMODE" os)                        ;Reset Snap Mode
 (setq s (ssname st 0)))                       ;Return Selection Name

(PDot);+++++++++++ Check UCS And Elevation +++++++++++++++++++++++++++++
 (defun ChkUCS ()                              ;Define Check UCS
  (setq edir (GetVal 210 bdef))                ;Get Ucs Extrusion
  (if (= (getvar "WORLDUCS") 1)                ;If World UCS
      (setq ex (trans edir 1 0 1))             ;Translate To World
      (setq ex (trans edir 0 1 0)))            ;Else Translate To User
  (if (not (equal ex (list 0 0 1) 0.000001))   ;If Not 0 0 1
      (Warn "Not Current UCS")))               ;Of UCS

(PDot);************ Main Program ***************************************
 (defun IRot (/ m_n m_v m_s m_l olderr edir ex s bdef bnm inpt crot newa spt)
  (ir_smd)                                     ;Set User Modes
; (setq *error* nil)                           ;Debugging Aid
; (setvar "CMDECHO" 1)                         ;Debugging Aid
  (GetOne)                                     ;Get Entity Name
  (setq bdef (entget s)                        ;Get Definition
        bnm (GetVal 2 bdef)                    ;Insert Name
        inpt (GetVal 10 bdef)                  ;Insert Point
        crot (GetVal 50 bdef))                 ;Insert Angle
  (if (/= "INSERT" (GetVal 0 bdef))            ;Abort If Not
      (err "Not An Insert Entity"))            ;An Insert
  (ChkUCS)                                     ;Check Current UCS
  (princ (strcat bnm                           ;Display
                 " Inserted At "               ;Current
                 (ir_p2s inpt)                 ;Point
                 " At "                        ;And
                 (rtos (rtoa crot) 2 0)        ;Angle
                 " Degree"))                   ;In Degrees
  (setq newa (getreal "\nEnter Angle In Degrees To Rotate Insert:   "))
  (command "ROTATE" s "" inpt newa)            ;Rotate Insert
  (ir_rmd))                                    ;Return Old Modes

(PDot);@@@@@@@@@@@@ Load Program @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 (defun C:IRot () (IRot))                      ;Make Command Resident
 (if IRot (princ "\nIRot Defined\n"))          ;Confirm Loading
 (prin1)                                       ;Else Display Errors
; End Program 
;"AS IS" Public Domain Software Donated By
;
;      
;                                    ͻ
;               ۳                                            
;                             Fabricated Designs, Inc.  
;            >    <                                         
;                              ͼ
;      
;
;
;
;        Fabricated Designs, Inc.
;        32 Maury Avenue
;        Newport News, Virginia  23601-2132
;         Ph: (804) 595-5949
;        FAX: (804) 595-5787
;
